package com.inca.npbusi.sales.bms_tr_fetch;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.ste.CSteModel;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.sales.bms_tr_fetch.tickhov.Bms_fetch_dtl_tick_hov;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.Apinfo;
import com.inca.pubsrv.Entrychose;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.bms_wf_instance_qry.Bms_wf_instance_qry_hov;
import com.inca.pubsrv.hov.bms_st_def_hov.Bms_st_def_hov;
import com.inca.zx.pubmethod.ZXCheckMethod;
import java.awt.Component;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.SwingUtilities;

public class Bms_tr_fetch_mde extends CMdeModelAp {
   private String a = "";
   private String b = "";
   private Component c = null;

   public String getEntryid() {
      return this.a;
   }

   public void setEntryid(String var1) {
      this.a = var1;
   }

   public String getEntryname() {
      return this.b;
   }

   public void setEntryname(String var1) {
      this.b = var1;
   }

   public Bms_tr_fetch_mde(CFrame var1, String var2) {
      super(var1, var2);
      this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
      this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
   }

   protected CMasterModel createMastermodel() {
      return new Bms_tr_fetch_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Bms_tr_fetch_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "Fetchid";
   }

   public String getDetailRelatecolname() {
      return "Fetchid";
   }

   public String getSaveCommandString() {
      return "Bms_tr_fetch_mde.保存销退申请单";
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector var1;
      (var1 = new Vector()).add(new Apinfo("确定", ""));
      var1.add(new Apinfo("重新下传数据至WMS", ""));
      var1.add(new Apinfo("作废", ""));
      var1.add(new Apinfo("禁止生成新批号", ""));
      var1.add(new Apinfo("下传物流通知权限", ""));
      var1.add(new Apinfo("中止", ""));
      return var1;
   }

   protected int on_actionPerformed(String var1) {
      if (var1.equals("确定")) {
         if (this.getApvalue("确定").equals("1")) {
            this.confrim();
            return 1;
         } else {
            this.infoMessage("提示", "您没有此操作权限！");
            return 0;
         }
      } else if (var1.equals("回退确定")) {
         if (this.getApvalue("回退确定").equals("1")) {
            this.unconfrim();
            return 1;
         } else {
            this.infoMessage("提示", "您没有此操作权限！");
            return 0;
         }
      } else {
         int var3;
         Bms_tr_fetch_mde var14;
         String var15;
         if (var1.equals("中止")) {
            if (!this.getApvalue("中止").equals("1")) {
               this.infoMessage("提示", "您没有此操作权限！");
               return 0;
            } else {
               var14 = this;
               if (this.getMasterModel().getRow() < 0) {
                  this.warnMessage("警告", "请查询或新增保存销退申请单再作废");
               } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
                  this.warnMessage("警告", "请查询或新增保存销退申请单再作废");
               } else {
                  for(var3 = 0; var3 < var14.getMasterModel().getRowCount(); ++var3) {
                     if (var14.getMasterModel().getdbStatus(var3) != 0) {
                        var14.warnMessage("警告", "有尚未保存的单据，请先做保存!");
                        return 1;
                     }
                  }

                  if (var14.getDetailModel().getRow() < 0) {
                     var14.warnMessage("警告", "请正确选择销退申请细单中止;");
                  } else if (var14.getDetailModel().getRow() == var14.getDetailModel().getDBtableModel().getRowCount()) {
                     var14.warnMessage("警告", "请正确选择销退申请细单中止;");
                  } else {
                     for(var3 = 0; var3 < var14.getDetailModel().getRowCount(); ++var3) {
                        if (var14.getDetailModel().getdbStatus(var3) != 0) {
                           var14.warnMessage("警告", "有尚未保存的单据，请先做保存!");
                           return 1;
                        }
                     }

                     var15 = var14.getMasterModel().getItemValue(var14.getMasterModel().getRow(), "usestatus");
                     if ("0".equals(var15)) {
                        var14.warnMessage("警告", "您选择的单据已经作废，不需要\"中止\"！");
                     } else {
                        int[] var19;
                        int var21 = (var19 = var14.getDetailModel().getTable().getSelectedRows()).length;
                        if (var14.getDetailModel().getTable().getSelectedRow() == var14.getDetailModel().getTable().getRowCount() - 1) {
                           var14.infoMessage("警告", "选中行错误,请重新选择!!!");
                        } else {
                           ParamCommand var24 = new ParamCommand();
                           int var26 = 0;

                           while(true) {
                              if (var26 >= var21) {
                                 ClientRequest var28 = new ClientRequest();
                                 ServerResponse var27 = null;
                                 var28.addCommand(new StringCommand("Bms_tr_fetch_mde.中止销退申请单"));
                                 var15 = var14.getMasterModel().getItemValue(var14.getMasterModel().getRow(), "fetchid");
                                 var28.addCommand(new StringCommand(var15));
                                 var28.addCommand(var24);

                                 try {
                                    var27 = SendHelper.sendRequest(var28);
                                 } catch (Exception var9) {
                                    var14.errorMessage("错误", var9.getMessage());
                                    var9.printStackTrace();
                                 }

                                 if ((var15 = ((StringCommand)var27.commandAt(0)).getString()).startsWith("+OK")) {
                                    for(var21 = 0; var21 < var19.length; ++var21) {
                                       var14.getDetailModel().setItemValue(var19[var21], "usestatus", "3");
                                       var14.getDetailModel().setdbStatus(var19[var21], 0);
                                    }

                                    var14.getDetailModel().tableChanged();
                                    var14.getMasterModel().setdbStatus(var14.getMasterModel().getRow(), 0);
                                    var14.getMasterModel().tableChanged();
                                    var14.infoMessage("提示", "中止操作完成！");
                                 } else {
                                    var14.infoMessage("错误", var15);
                                 }
                                 break;
                              }

                              if (!var14.getDetailModel().getItemValue(var19[var26], "usestatus").equals("1")) {
                                 var14.infoMessage("提示", "细单处理状态只有是\"未到货\"的才需要中止;");
                                 break;
                              }

                              if ((var15 = var14.getMasterModel().getItemValue(var14.getMasterModel().getRow(), "wfusestatus")) == null) {
                                 var15 = "";
                              }

                              if ("1".equals(var15)) {
                                 var14.warnMessage("警告", "已送审，不能进行此操作！");
                                 break;
                              }

                              var24.addParam("fetchdtlid" + var26, var14.getDetailModel().getItemValue(var19[var26], "fetchdtlid"));
                              ++var26;
                           }
                        }
                     }
                  }
               }

               return 1;
            }
         } else if (var1.equals("作废")) {
            if (this.getApvalue("作废").equals("1")) {
               this.invalid();
               return 1;
            } else {
               this.infoMessage("提示", "您没有此操作权限！");
               return 0;
            }
         } else if (var1.equals("选择原销售单生成明细")) {
            this.b();
            return 1;
         } else {
            String var2;
            if (var1.equals("送审")) {
               var2 = "";

               try {
                  var2 = NpbusiDBHelper.getSysParaConfig(ClientUserManager.getCurrentUser().getEntryid(), "wf1111");
               } catch (Exception var12) {
                  var12.printStackTrace();
               }

               if (!var2.equals("1")) {
                  this.infoMessage("提示！", "请启动审批流再送审！");
                  return 0;
               }
            }

            String var5;
            if (var1.equals("查看审批流")) {
               if (this.getMasterModel().getRowCount() <= 0) {
                  this.infoMessage("提示", "请选中数据行！");
               } else {
                  var3 = this.getMasterModel().getRow();
                  Bms_wf_instance_qry_hov var4 = new Bms_wf_instance_qry_hov();
                  var5 = this.getMasterModel().getItemValue(var3, "FETCHID");
                  String var6 = " TABLENAME LIKE 'BMS_TR_FETCH_DOC'  AND PKCOLNAME LIKE 'FETCHID' and PKVALUE =" + var5;
                  var4.showDialog(this.frame, "查看审批流", "TABLENAME", "%", var6);
               }
            }

            if (var1.equals("切换独立单元")) {
               if (this.mastermodel.getModifiedDbmodel().getRowCount() > 0) {
                  this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
                  return -1;
               } else {
                  if (Entrychose.setUserEntryInfo(this.frame)) {
                     this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
                     this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
                     this.getMasterModel().doRetrieve("1=2");
                  }

                  return 0;
               }
            } else if (var1.equals("下传物流通知")) {
               var2 = this.getApvalue("下传物流通知权限");
               if ("1".equals(var2)) {
                  JPopupMenu var18 = createMenu(this, "1");
                  Point var13 = SwingUtilities.convertPoint(this.c, this.c.getX(), this.c.getY() + this.c.getHeight(), this.frame.getRootPane().getContentPane());
                  var18.show(this.frame.getRootPane().getContentPane(), (int)var13.getX() - this.c.getX(), (int)var13.getY());
                  return 0;
               } else {
                  this.infoMessage("提示", "你没有下传物流通知的权限！");
                  return -1;
               }
            } else {
               if (var1.equals("按总单生成")) {
                  this.a("0");
               } else if (var1.equals("按细单生成")) {
                  this.a("1");
               } else if (var1.equals("重新下传数据至WMS")) {
                  var2 = this.getApvalue("重新下传数据至WMS");
                  if (!"1".equals(var2)) {
                     this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
                     return -1;
                  }

                  var14 = this;
                  if (this.getMasterModel().getRow() < 0) {
                     this.warnMessage("警告", "请选择正确的单据进行审批!");
                  } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
                     this.warnMessage("警告", "请选择正确的单据进行审批!");
                  } else {
                     var3 = this.mastermodel.getTable().getSelectedRow();
                     String var16 = this.mastermodel.getItemValue(var3, "fetchid");
                     var5 = " select towmsflag from bms_tr_fetch_doc where fetchid= " + var16;
                     RemotesqlHelper var22 = new RemotesqlHelper();
                     DBTableModel var7 = null;

                     try {
                        var7 = var22.doSelect(var5, 0, 1);
                     } catch (Exception var11) {
                        var11.printStackTrace();
                     }

                     String var8 = var7.getItemValue(0, "towmsflag");
                     if (!this.mastermodel.getItemValue(var3, "usestatus").equals("1")) {
                        this.warnMessage("警告", "总单状态不是正式状态，不能重新下发！");
                     } else if ("2".equals(var8)) {
                        this.warnMessage("警告", "已经下发2次了，不能重新下发！");
                     } else {
                        var15 = NpbusiDBHelper.getSysdate();
                        ClientRequest var20 = new ClientRequest();
                        StringCommand var23 = new StringCommand("销售退货单重新下传wms");
                        ParamCommand var25;
                        (var25 = new ParamCommand()).addParam("fetchid", var16);
                        var25.addParam("sysdate", var15);
                        var20.addCommand(var23);
                        var20.addCommand(var25);
                        var15 = null;

                        try {
                           StringCommand var17;
                           if ((var17 = (StringCommand)SendHelper.sendRequest(var20).commandAt(0)).getString().startsWith("+OK")) {
                              var14.infoMessage("提示", "重新下传成功!");
                              var14.mastermodel.doRequery();
                           } else {
                              var14.infoMessage("提示", "确定失败或下发wms失败,原因:" + var17);
                              var14.mastermodel.doRequery();
                           }
                        } catch (Exception var10) {
                           var10.printStackTrace();
                           this.errorMessage("错误", "不成功原因:" + var10.getMessage());
                           this.mastermodel.doRequery();
                        }
                     }
                  }
               }

               return super.on_actionPerformed(var1);
            }
         }
      }
   }

   public void actionPerformed(ActionEvent var1) {
      if (var1.getActionCommand().equals("下传物流通知")) {
         this.c = (Component)var1.getSource();
      }

      super.actionPerformed(var1);
   }

   public static JPopupMenu createMenu(ActionListener var0, String var1) {
      JPopupMenu var2 = new JPopupMenu("操作");
      if ("1".equals(var1)) {
         JMenuItem var3;
         (var3 = new JMenuItem("按总单生成通知")).setActionCommand("按总单生成");
         var3.addActionListener(var0);
         var2.add(var3);
         (var3 = new JMenuItem("按细单生成通知")).setActionCommand("按细单生成");
         var3.addActionListener(var0);
         var2.add(var3);
      }

      return var2;
   }

   private void a(String var1) {
      if (this.getModifiedRowCount() > 0) {
         this.errorMessage("错误", "请先保存所有单据");
      } else {
         int[] var2;
         if ((var2 = this.getMasterModel().getTable().getSelectedRows()).length <= 0) {
            this.errorMessage("错误", "请选择销退申请单记录");
         } else {
            Bms_st_def_hov var3 = new Bms_st_def_hov();
            String var4 = ClientUserManager.getCurrentUser().getEntryid();
            DBTableModel var13;
            if ((var13 = var3.showDialog(this.frame, "选择收货保管帐", "storageid", "", "nvl(presflag,0) = 0  and entryid = " + var4)) != null) {
               String var5 = var13.getItemValue(0, "storageid");
               String var14 = var13.getItemValue(0, "phystoreid");
               Vector var15 = new Vector();
               DBColumnDisplayInfo var6 = new DBColumnDisplayInfo("fetchid", "number");
               var15.add(var6);
               var6 = new DBColumnDisplayInfo("fetchdtlid", "number");
               var15.add(var6);
               var6 = new DBColumnDisplayInfo("entryid", "number");
               var15.add(var6);
               var6 = new DBColumnDisplayInfo("sendflag", "number");
               var15.add(var6);
               var6 = new DBColumnDisplayInfo("message", "varchar");
               var15.add(var6);
               DBTableModel var16 = new DBTableModel(var15);
               int var7;
               String var8;
               String var9;
               if ("0".equals(var1)) {
                  for(var7 = 0; var7 < var2.length; ++var7) {
                     var8 = this.getMasterModel().getItemValue(var2[var7], "fetchid");
                     var9 = this.getMasterModel().getItemValue(var2[var7], "usestatus");
                     if (!"1".equals(var9)) {
                        this.errorMessage("错误", "第" + (var2[var7] + 1) + "行总单状态不符合要求");
                        return;
                     }

                     var4 = this.getMasterModel().getItemValue(var2[var7], "entryid");
                     var16.appendRow();
                     var16.setItemValue(var16.getRowCount() - 1, "fetchid", var8);
                     var16.setItemValue(var16.getRowCount() - 1, "entryid", var4);
                  }
               } else if ("1".equals(var1)) {
                  var2 = this.getDetailModel().getTable().getSelectedRows();

                  for(var7 = 0; var7 < var2.length; ++var7) {
                     var8 = this.getDetailModel().getItemValue(var2[var7], "fetchid");
                     var9 = this.getDetailModel().getItemValue(var2[var7], "fetchdtlid");
                     var4 = this.getDetailModel().getItemValue(var2[var7], "usestatus");
                     if (!"1".equals(var4)) {
                        this.errorMessage("错误", "第" + (var7 + 1) + "行细单状态不符合要求");
                        return;
                     }

                     var4 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "entryid");
                     var16.appendRow();
                     var16.setItemValue(var16.getRowCount() - 1, "fetchid", var8);
                     var16.setItemValue(var16.getRowCount() - 1, "fetchdtlid", var9);
                     var16.setItemValue(var16.getRowCount() - 1, "entryid", var4);
                  }
               }

               DataCommand var17;
               (var17 = new DataCommand()).setDbmodel(var16);
               ClientRequest var18;
               (var18 = new ClientRequest()).addCommand(new StringCommand("Bms_tr_fetch_mde.销退申请生成收货通知单"));
               var18.addCommand(new StringCommand(var5));
               var18.addCommand(new StringCommand(var14));
               var18.addCommand(new StringCommand(var1));
               var18.addCommand(var17);
               var9 = null;

               try {
                  if (!(var4 = ((StringCommand)SendHelper.sendRequest(var18).commandAt(0)).getString()).startsWith("+OK")) {
                     this.errorMessage("错误", "下传物流通知的时候发生错误,错误原因为:" + var4);
                  } else {
                     this.infoMessage("提示", "成功下传物流通知");
                     int var11;
                     if ("1".equals(var1)) {
                        for(var11 = 0; var11 < var2.length; ++var11) {
                           this.getDetailModel().setItemValue(var2[var11], "sendflag", "1");
                           this.getDetailModel().setdbStatus(var2[var11], 0);
                           this.getDetailModel().tableChanged();
                        }

                     } else {
                        if ("0".equals(var1)) {
                           var11 = this.getDetailModel().getRowCount();

                           for(int var12 = 0; var12 < var11; ++var12) {
                              this.getDetailModel().setItemValue(var12, "sendflag", "1");
                              this.getDetailModel().setdbStatus(var12, 0);
                              this.getDetailModel().tableChanged();
                           }
                        }

                     }
                  }
               } catch (Exception var10) {
                  var10.printStackTrace();
                  this.infoMessage("提示", "下传物流通知失败,原因:" + var10.getMessage());
               }
            }
         }
      }
   }

   protected void confrim() {
      if (this.getMasterModel().getRowCount() <= 0) {
         this.infoMessage("提示", "请选择数据行！");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请查询或新增保存再确认");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存不能确定,请先保存!");
               return;
            }
         }

         DBTableModel var9 = a();
         int[] var2 = this.getMasterModel().getTable().getSelectedRows();

         for(int var3 = 0; var3 < var2.length; ++var3) {
            String var4 = this.getMasterModel().getItemValue(var2[var3], "usestatus");
            if (!"2".equals(var4)) {
               this.warnMessage("警告", "不能选择不是临时状态的销退申请单进行确定!");
               return;
            }

            String var5 = "";

            try {
               var5 = NpbusiDBHelper.getSysParaConfig(ClientUserManager.getCurrentUser().getEntryid(), "wf1111");
            } catch (Exception var8) {
               var8.printStackTrace();
            }

            if (var5.equals("1")) {
               String var6;
               if ((var6 = this.getMasterModel().getItemValue(var2[var3], "wfusestatus")) == null) {
                  var6 = "";
               }

               if (!"2".equals(var6)) {
                  this.warnMessage("警告", "已启动审批流，没有审批完成，不能确定！");
                  return;
               }
            }

            int var20 = var9.getRowCount();
            var9.appendRow();
            var9.setItemValue(var20, "fetchid", this.getMasterModel().getItemValue(var2[var3], "fetchid"));
         }

         if (var9.getRowCount() <= 0) {
            this.warnMessage("警告", "请选择销退申请单进行确定");
         } else {
            Vector var10 = new Vector();
            DBColumnDisplayInfo var12 = new DBColumnDisplayInfo("sysdate", "date");
            var10.add(var12);
            DBTableModel var14;
            (var14 = new DBTableModel(var10)).appendRow();
            var14.setItemValue(0, "sysdate", NpbusiDBHelper.getSysdate());
            DataCommand var15;
            (var15 = new DataCommand()).setDbmodel(var14);
            ClientRequest var18;
            (var18 = new ClientRequest()).addCommand(new StringCommand("Bms_tr_fetch_mde.确定销退申请单"));
            DataCommand var21;
            (var21 = new DataCommand()).setDbmodel(var9);
            var18.addCommand(var21);
            var18.addCommand(var15);
            ServerResponse var11 = null;

            try {
               var11 = SendHelper.sendRequest(var18);
            } catch (Exception var7) {
               this.errorMessage("错误", var7.getMessage());
               var7.printStackTrace();
            }

            String var16;
            if (!(var16 = ((StringCommand)var11.commandAt(0)).getString()).startsWith("+OK")) {
               this.infoMessage("提示", "确定失败或下发wms失败,原因:" + var16);
               this.mastermodel.doRequery();
            } else {
               for(int var13 = 0; var13 < var9.getRowCount(); ++var13) {
                  var16 = var9.getItemValue(var13, "fetchid");
                  DBTableModel var17 = this.getMasterModel().getDBtableModel();

                  for(int var19 = 0; var19 < var17.getRowCount(); ++var19) {
                     if (var17.getItemValue(var19, "fetchid").equals(var16)) {
                        var17.setItemValue(var19, "usestatus", "1");
                        var17.setItemValue(var19, "confirmdate", NpbusiDBHelper.getSysdate());
                        var17.setItemValue(var19, "confirmmanname", ClientUserManager.getCurrentUser().getUsername());
                        var17.setItemValue(var19, "confirmmanid", ClientUserManager.getCurrentUser().getUserid());
                        var17.setdbStatus(var19, 0);
                        break;
                     }
                  }
               }

               this.getMasterModel().tableChanged();
               this.infoMessage("提示", "确定成功！");
               this.mastermodel.doRequery();
            }
         }
      }
   }

   protected void invalid() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请查询或新增保存销退申请单再作废");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请查询或新增保存销退申请单再作废");
      } else {
         String var1;
         if ((var1 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "wfusestatus")) == null) {
            var1 = "";
         }

         if (!"1".equals(var1) && !"2".equals(var1)) {
            int var9;
            for(var9 = 0; var9 < this.getMasterModel().getRowCount(); ++var9) {
               if (this.getMasterModel().getdbStatus(var9) != 0) {
                  this.warnMessage("警告", "没有保存不能作废,请先保存!");
                  return;
               }
            }

            if (this.getDetailModel().getRow() < 0) {
               this.warnMessage("警告", "请先选择销退申请单再作废");
            } else if (this.getDetailModel().getRow() == this.getDetailModel().getDBtableModel().getRowCount()) {
               this.warnMessage("警告", "请先选择销退申请单细单再作废");
            } else {
               for(var9 = 0; var9 < this.getDetailModel().getRowCount(); ++var9) {
                  if (this.getDetailModel().getdbStatus(var9) != 0) {
                     this.warnMessage("警告", "没有保存不能作废,请先保存!");
                     return;
                  }
               }

               var1 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
               if (!"0".equals(var1) && !"2".equals(var1)) {
                  Vector var13 = new Vector();
                  DBColumnDisplayInfo var2 = new DBColumnDisplayInfo("fetchdtlid", "number");
                  var13.add(var2);
                  var2 = new DBColumnDisplayInfo("message", "varchar");
                  var13.add(var2);
                  DBTableModel var14 = new DBTableModel(var13);
                  int[] var10;
                  int var3 = (var10 = this.getDetailModel().getTable().getSelectedRows()).length;
                  if (this.getDetailModel().getTable().getSelectedRow() == this.getDetailModel().getTable().getRowCount() - 1) {
                     this.infoMessage("警告", "选中行错误,请重新选择!!!");
                  } else {
                     for(int var4 = 0; var4 < var3; ++var4) {
                        if (this.getDetailModel().getItemValue(var10[var4], "usestatus").equals("1")) {
                           int var5 = var14.getRowCount();
                           var14.appendRow();
                           var14.setItemValue(var5, "fetchdtlid", this.getDetailModel().getItemValue(var10[var4], "fetchdtlid"));
                        }
                     }

                     if (var14.getRowCount() <= 0) {
                        this.warnMessage("警告", "请选择没有作废的进货退货细单进行作废");
                     } else {
                        ClientRequest var16 = new ClientRequest();
                        String var18 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "fetchid");
                        var16.addCommand(new StringCommand("Bms_tr_fetch_mde.作废销退申请单"));
                        var16.addCommand(new StringCommand(var18));
                        DataCommand var19;
                        (var19 = new DataCommand()).setDbmodel(var14);
                        var16.addCommand(var19);
                        ServerResponse var11 = null;

                        try {
                           var11 = SendHelper.sendRequest(var16);
                        } catch (Exception var8) {
                           this.errorMessage("错误", var8.getMessage());
                           var8.printStackTrace();
                        }

                        String var12;
                        if (!(var12 = ((StringCommand)var11.commandAt(0)).getString()).startsWith("+OK")) {
                           this.infoMessage("错误", var12);
                        } else {
                           for(int var15 = 0; var15 < var14.getRowCount(); ++var15) {
                              String var17 = var14.getItemValue(var15, "fetchdtlid");
                              DBTableModel var20 = this.getDetailModel().getDBtableModel();

                              for(int var6 = 0; var6 < var20.getRowCount(); ++var6) {
                                 if (var20.getItemValue(var6, "fetchdtlid").equals(var17)) {
                                    var20.setItemValue(var6, "usestatus", "0");
                                    var20.setItemValue(var6, "invaliddate", NpbusiDBHelper.getSysdate());
                                    var20.setItemValue(var6, "invalidmanname", ClientUserManager.getCurrentUser().getUsername());
                                    var20.setItemValue(var6, "invalidmanid", ClientUserManager.getCurrentUser().getUserid());
                                    var20.setdbStatus(var6, 0);
                                    break;
                                 }
                              }
                           }

                           this.getDetailModel().tableChanged();
                           if (var12.startsWith("+OKDOC")) {
                              this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "usestatus", "0");
                              this.getMasterModel().setdbStatus(this.getMasterModel().getRow(), 0);
                              this.getMasterModel().tableChanged();
                           }

                           this.infoMessage("提示", "作废成功！");
                        }
                     }
                  }
               } else {
                  this.warnMessage("警告", "您目前选择的单据已经作废或是临时状态，不能作废！只有正常状态单据允许作废！");
               }
            }
         } else {
            this.warnMessage("警告", "已送审，不能进行此操作！");
         }
      }
   }

   private static DBTableModel a() {
      Vector var0 = new Vector();
      DBColumnDisplayInfo var1 = new DBColumnDisplayInfo("fetchid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("message", "varchar");
      var0.add(var1);
      return new DBTableModel(var0);
   }

   private void b() {
      String[] var1 = new String[]{"storageid"};
      CSteModel var2;
      int var3;
      if ((var3 = (var2 = this.getMasterModel()).getRow()) < 0) {
         this.warnMessage("警告", "请选择正确的单据!");
      } else if (var3 == var2.getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据!");
      } else if (((Bms_tr_fetch_master)var2).checkRow(var3) != -1) {
         String var4 = var2.getItemValue(var3, "usestatus");
         if (!"0".equals(var4) && !"1".equals(var4)) {
            if ((var4 = var2.getItemValue(var2.getRow(), "wfusestatus")) == null) {
               var4 = "";
            }

            if (!"1".equals(var4) && !"2".equals(var4)) {
               if ((var4 = var2.getItemValue(var3, "companyid")) != null && !"".equals(var4)) {
                  String var6;
                  for(int var5 = 0; var5 < var1.length; ++var5) {
                     if ((var6 = var2.getItemValue(var3, var1[var5])) == null || var6.equals("")) {
                        DBColumnDisplayInfo var9 = var2.getDBColumnDisplayInfo(var1[var5]);
                        this.errorMessage("错误", String.format("“%s”必填", var9.getTitle()));
                        return;
                     }
                  }

                  Bms_fetch_dtl_tick_hov var13 = new Bms_fetch_dtl_tick_hov();
                  var6 = ClientUserManager.getCurrentUser().getEntryid();
                  String var10;
                  if ((var10 = var2.getItemValue(var3, "agentid")).equals("") || var10 == null) {
                     var10 = "-1";
                  }

                  String var7 = var2.getItemValue(var3, "salerid");
                  String var8 = var2.getItemValue(var3, "storageid");
                  var10 = " nvl(allowbackflag,1) = 1 and customid = " + var4 + " and satypeid = 1 and entryid=" + var6 + " and nvl(agentid,-1)=" + var10 + " and salerid = " + var7 + " and nvl(goodsqty, 0) > nvl(backQty, 0) and storageid=" + ZXCheckMethod.isNullRe_one(var8) + " and  rownum<=100 ";
                  if (var13.showDialog(this.frame, "选择销售细单", "settletypeid", "%", var10) != null) {
                     CTable var11;
                     int[] var14 = (var11 = var13.getTable()).getSelectedRows();
                     DBTableModel var12 = (DBTableModel)var11.getModel();
                     if (var14.length > 0) {
                        ((Bms_tr_fetch_detail)this.getDetailModel()).gensabackdtl(var14, var12);
                        this.getDetailModel().getDBColumnDisplayInfo("batchflag").setReadonly(true);
                        this.getDetailModel().getDBColumnDisplayInfo("batchprice").setReadonly(true);
                        if (var2.getdbStatus(var3) == 0) {
                           var2.setdbStatus(var3, 2);
                        }

                        var2.tableChanged();
                        this.getDetailModel().tableChanged();
                     }
                  }
               } else {
                  this.warnMessage("警告", "请先录入客户！");
               }
            } else {
               this.warnMessage("警告", "已送审，不能进行此操作！");
            }
         } else {
            this.warnMessage("警告", "选择销退申请单已作废或确定，不能生成！");
         }
      }
   }

   protected void unconfrim() {
      if (this.getMasterModel().getRowCount() <= 0) {
         this.infoMessage("提示", "请选择数据行！");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请查询或新增保存再回退确认");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存不能确定,请先保存!");
               return;
            }
         }

         DBTableModel var8 = a();
         int[] var2 = this.getMasterModel().getTable().getSelectedRows();

         for(int var3 = 0; var3 < var2.length; ++var3) {
            String var4 = this.getMasterModel().getItemValue(var2[var3], "usestatus");
            if (!"1".equals(var4)) {
               this.warnMessage("警告", "请选择正常状态销退申请单进行回退确定!");
               return;
            }

            int var13 = var8.getRowCount();
            var8.appendRow();
            var8.setItemValue(var13, "fetchid", this.getMasterModel().getItemValue(var2[var3], "fetchid"));
         }

         if (var8.getRowCount() <= 0) {
            this.warnMessage("警告", "请选择销退申请单进行回退确定");
         } else {
            ClientRequest var11;
            (var11 = new ClientRequest()).addCommand(new StringCommand("Bms_tr_fetch_mde.回退确定销退申请单"));
            DataCommand var14;
            (var14 = new DataCommand()).setDbmodel(var8);
            var11.addCommand(var14);
            ServerResponse var15 = null;

            try {
               var15 = SendHelper.sendRequest(var11);
            } catch (Exception var7) {
               this.errorMessage("错误", var7.getMessage());
               var7.printStackTrace();
            }

            String var9;
            if (!(var9 = ((StringCommand)var15.commandAt(0)).getString()).startsWith("+OK")) {
               this.infoMessage("错误", var9);
            } else {
               for(int var10 = 0; var10 < var8.getRowCount(); ++var10) {
                  String var12 = var8.getItemValue(var10, "fetchid");
                  DBTableModel var16 = this.getMasterModel().getDBtableModel();

                  for(int var5 = 0; var5 < var16.getRowCount(); ++var5) {
                     if (var16.getItemValue(var5, "fetchid").equals(var12)) {
                        var16.setItemValue(var5, "usestatus", "2");
                        var16.setItemValue(var5, "confirmdate", "");
                        var16.setItemValue(var5, "confirmmanname", "");
                        var16.setItemValue(var5, "confirmmanid", "");
                        var16.setdbStatus(var5, 0);
                        break;
                     }
                  }
               }

               this.getMasterModel().tableChanged();
               this.infoMessage("提示", "回退成功！");
            }
         }
      }
   }
}
